# load the estimated roughness parameters from GEM-SA
b<-scan("C:/Program Files/gem-SA/emulator_rough_out.dat")

# load the input and output files
inputs<-matrix(scan("C:/inputs.txt"),nrow=100,ncol=5,byrow=T)
outputs<-matrix(scan("C:/outputs.txt"),nrow=100,ncol=1)

# GEM-SA standardises each input to [0,1]
# rescale the roughness parameters back to the original scale

w<-apply(inputs,2,max)-apply(inputs,2,min)
b<-b/w^2

# Compute betahat and A^{-1} for use in the emulator prediction
B<-diag(b)
n<-length(inputs[,1])

R<-inputs%*%B%*%t(inputs)
S<-matrix(diag(R),nrow=n,ncol=n)
A<-exp(2*R-S-t(S))
Ainv<-solve(A)
H<-cbind(1,inputs)
betahat<-solve(t(H)%*%Ainv%*%H)%*%t(H)%*%Ainv%*%outputs
r<-Ainv%*%(outputs-H%*%betahat)
