# Define a vector giving the distribution of each input
# use 'n' - normal, 'l' - lognormal, 'b' - beta, 'g' - gamma, 'u' - uniform

distributions<-c('n','l','g','b','u')

np<-length(distributions) #np is the number of input variables

# Define a npx2 matrix of parameter values for each distribution
# Distribution      1st parameter       2nd parameter
# normal            mean                sd
# lognormal         mean of log         sd of log
# beta              a                   b               E(x)=a/(a+b)
# gamma             shape               rate            E(x)=shape/rate
# uniform           lower limit         upper limit

parameters<-matrix(c(0,1,0,1,3,2,10,20,0,5),nrow=np,ncol=2,byrow=T)


# Generate (e.g. 100) design points to evaluate the model at

inputs<-setupdesign(100,distributions,parameters)

# Write the inputs to a file 

write(t(inputs),"c:/inputs.txt",ncolumns=np)
