setupdesign<-function(n,distributions,parameters){
# Function for generating a maximin Latin Hypercube Design
# n: number of design points (maximum of 400)
# distributions: string vector of input parameter distributions:
# 'n' - normal, 'b' - beta, 'g' - gamma, 'u' - uniform
# parameters: (no. of inputs)x2 matrix 


# Evaluate lower and upper limits for each parameter

ninputs<-length(distributions)
limits<-matrix(0,nrow=ninputs,ncol=2)
design<-matrix(0,nrow=n,ncol=ninputs)
for(i in 1:ninputs){
  limits[i,1]<-switch(distributions[i],
  n = qnorm(0.005,parameters[i,1],parameters[i,2]),
  l = qlnorm(0.005,parameters[i,1],parameters[i,2]),
  b = qbeta(0.005,parameters[i,1],parameters[i,2]),
  g = qgamma(0.005,parameters[i,1],parameters[i,2]),
  u = parameters[i,1])
  
  limits[i,2]<-switch(distributions[i],
  n = qnorm(0.995,parameters[i,1],parameters[i,2]),
  l = qlnorm(0.995,parameters[i,1],parameters[i,2]),
  b = qbeta(0.995,parameters[i,1],parameters[i,2]),
  g = qgamma(0.995,parameters[i,1],parameters[i,2]),
  u = parameters[i,2])
  }
  
  design<-matrix(seq(from=0,to=1,length=n),nrow=n,ncol=ninputs)
  
design<-apply(design,2,sample)
R<-design%*%t(design)
S<-matrix(diag(R),nrow=n,ncol=n)
distances<--2*R+S+t(S)+1000*diag(n)
mindist<-min(distances)

currentmin<-mindist
currentdesign<-design
count<-0
for(i in 1:1000){
design<-apply(design,2,sample)
R<-design%*%t(design)
S<-matrix(diag(R),nrow=n,ncol=n)
distances<--2*R+S+t(S)+1000*diag(n)
mindist<-min(distances)

if(mindist>currentmin){
currentdesign<-design
currentmin<-mindist
print(mindist)
count<-count+1
}
}
currentdesign<-matrix(limits[,1],nrow=n,ncol=ninputs,byrow=T)+currentdesign*matrix(limits[,2]-limits[,1],nrow=n,ncol=ninputs,byrow=T)
currentdesign

}
